'''combat
'''

import random
import sound

class Arena(object):
    def __init__(self):
        self.seconds_per_round = 0.5
        self.cooldown = 0.0

    def update_combat_cooldown(self, dt):
        self.cooldown -= dt
        if self.cooldown < 0:
            self.cooldown = 0.0

    def combat_round(self, player, monster, printconsole):
        if self.cooldown > 0:
            return
        # Roll for initiative
        roll = random.random()
        if roll > 0.5:
            monster.combat.attacked_by(player.combat, 'player_attack')
            if monster.combat.damage_points > 0:
                player.combat.attacked_by(monster.combat, 'monster_attack')
        else:
            player.combat.attacked_by(monster.combat, 'monster_attack')
            if player.combat.damage_points > 0:
                monster.combat.attacked_by(player.combat, 'player_attack')
        self.cooldown = self.seconds_per_round


class Combat(object):
    def __init__(self, g, name = 'Unknown',
                 damage_points = 100, attack_power = 10,
                 attack_rating = 10, defense_rating = 10):
        self.name = name
        self.damage_points = damage_points
        self.max_damage_points = damage_points
        self.attack_power = attack_power
        self.attack_rating = attack_rating
        self.defense_rating = defense_rating
        self.g = g

    def attacked_by(self, attacker, sound = None):
        success = 0.5 + 0.1 * (attacker.attack_rating - self.defense_rating)
        if success < 0.01:
            success = 0.01
        if success > 0.99:
            success = 0.99
        roll = random.random()
        if roll < success:
            damage = attacker.attack_power
            self.damage_points -= damage
            self.g.gui.printconsole("%s hits %s for %d points!" \
                                   % (attacker.name, self.name, damage))
            self.g.sound.play_sound(sound)
        else:
            self.g.gui.printconsole("%s misses!" % attacker.name)
            self.g.sound.play_sound('attack_miss')

    def add_health(self,heals):
        self.damage_points += heals
        if self.damage_points > self.max_damage_points:
            self.damage_points = self.max_damage_points
        self.g.gui.printconsole("Healed %d points" % heals)

