'''Enemy monsters
'''

import mob
from mob import Mob
import misc
import combat

class Monster(Mob):
    def __init__(self, g, x, y):
        mob.Mob.__init__(self, g, x, y)
        self.collision_type = misc.COLLTYPE_MONSTER
        self.combat = combat.Combat(g, name = "monster", damage_points = 20,
                                    attack_power = 15)

    def post_phystep(self):
        mob.Mob.post_phystep(self)
        if self.state == misc.STATE_REAP:
            self.g.monsterlist.remove(self)

    def die_action(self):
        self.g.inventory.score += 1
        self.g.gui.printconsole('You loot 1 cm of string!')


def collision(a, b, contacts, normal, g):
    '''Collision function for collision between player and monster
    '''
    if a.collision_type == misc.COLLTYPE_MONSTER:
        monstershape = a
    elif b.collision_type == misc.COLLTYPE_MONSTER:
        monstershape = b
    else:
        # this should never happen
        print "didn't find monster"
        return True
    targetmonster= 0
    for monster in g.monsterlist:
        if monster.shape == monstershape:
            targetmonster = monster
    if targetmonster:
        g.arena.combat_round(g.player, targetmonster, g.gui.printconsole)
    return True

